/**
* High Availability App
* There are different ways implementing an App
*/
var HaApp = HaApp || {};  //Define App namespace, if you want.
/**
*Constructor UNAS App
*/
HaApp.App = function () {
    this.id = 'ha';
    this.name = 'High Availability';
    this.version = '6.1.14';
    this.active = false;
    this.menuIcon = '/apps/ha/images/logo.png?v=6.1.14&';
    this.shortcutIcon = '/apps/ha/images/logo.png?v=6.1.14&';
    this.entryUrl = '/apps/ha/ha.html?v=6.1.14&';
    var self = this;
    this.HaAppWindow = function () { //create app window
        if(UNAS.CheckAppState('Ha')){
            return false;
        }
        self.window=new MUI.Window({
            id: 'HaAppWindow',
            title: UNAS._('High Availability'),
            icon: '/apps/ha/images/logo_small.png?v=6.1.14&',
            width: 880,
            height: 500,
            maximizable: false,
            resizable: true,
            scrollbars: false,
            resizeLimit: { 'x': [750, 2000], 'y': [450, 1500] },
            loadMethod: 'xhr',
            contentURL: '/apps/ha/ha.html?v=6.1.14&',
            require: {  css: [
              '/apps/ha/css/ha.css?v=6.1.14&',
              '/apps/ha/css/alert.css?v=6.1.14&'
            ] },
            onBeforeBuild: function(){UNAS.SetAppOpenedWindow("Ha",'HaAppWindow')},
            onClose:function(){
              clearTimeout(halastTimer);
            }
        });
    };
    this.HaAppUninstall = function (){
        UNAS.RemoveDesktopShortcut('Ha');
        UNAS.RemoveMenu('Ha');
        UNAS.RemoveAppFromGroups('Ha', 'ControlPanel');
        UNAS.RemoveAppFromGroups('Ha', 'Help');
        UNAS.RemoveAppFromApps('Ha');
    }
    new UNAS.Menu('UNAS_App_SystemTools_Menu', this.name, this.menuIcon, 'High Availability', '', this.HaAppWindow);
    new UNAS.RegisterToAppGroup(this.name, 'ControlPanel', {Type: 'SystemTools', Location: 6, Icon: this.shortcutIcon, Url: this.entryUrl}, {});
    var OnChangeLanguage = function (e) {
        UNAS.SetMenuTitle('Ha', UNAS._('High Availability')); //translate menu
        if (typeof self.window !== 'undefined') {
            UNAS.SetWindowTitle('HaAppWindow', UNAS._('High Availability'));
        }
    }
    UNAS.LoadTranslation('/apps/ha/languages/Translation?v='+this.version, OnChangeLanguage);
    UNAS.Event.addEvent('ChangeLanguage', OnChangeLanguage);
    UNAS.CreateApp(this.name,this.shortcutIcon,this.HaAppWindow,this.HaAppUninstall);
};
new HaApp.App(); //Create app
