//获取主服务器配置
function get_host_conf() {
  jQuery('#jv-service-iface-warning').empty().hide();
  jQuery('#jv-heartbeat-iface-warning').empty().hide();
  jQuery('#jv-volume-warning').empty().hide();
  jQuery('#jv-ip-warning').empty().hide();
  jQuery('#createtarget_ip').attr('class', 'unas_input');
  jQuery('#jv-diskhost').empty();
  jQuery('#jv-createha-loading').show();
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: HaGlobalData.url,
      type: 'POST',
      data: JSON.encode({
        cmd: 'get_host_conf',
        token: UToken
      }),
      timeout: 60000,
      dataType: 'json',
      contentType: 'application/json',
      success: function(data) {
        if (data.err == 0) {
          var info = data.results || {};
          var disks = {
            available: [],
            unavailable: []
          }
          var service = {
            available: [],
            unavailable: []
          }
          var heartbeat = {
            available: [],
            unavailable: []
          }

          for (var i = 0; i < info.ifaces.length; i++) {
            if (i == 1) {
              info.ifaces[i]['type'] = 'heartbeat'
            }
            service.available.push(info.ifaces[i]);
            heartbeat.available.push(info.ifaces[i]);
          }
          jQuery('#jv-mastername').attr('hostname', info.hostname);

          for (var i = 0; i < info.disks.length; i++) {
            var d_ = info.disks[i];
            var diskdom = haManagerTemplateAppend('#jv-diskhost', 'jvt-diskitem', 'jvt-diskitem-' + i);
            diskdom.attr('style', '');
            diskdom.find('.jvc-diskname').text(d_.dev || '--');
            diskdom.find('.jvc-type').text(d_.type || '--');
            var size = UNAS.getReadableSizeString(d_.size || 0);
            diskdom.find('.jvc-size').text(size);
            diskdom.find('input[name="disk"]').val(d_.dev).on('click', function() {
              var disks = jQuery('#jv-diskhost input[name="disk"]');
              var diskck = jQuery('#jv-diskhost input[name="disk"]:checked');
              if (diskck.length == disks.length) {
                jQuery('#jv-selAlldisk').prop('checked', true);
              } else {
                jQuery('#jv-selAlldisk').prop('checked', false);
              }
              changeBtn();
            });
          }
          TranslatePage_HA('jv-diskhost');
          // if (service.available.length === 0) {
          //   jQuery('#jv-service-iface-warning').html(UNAS._('##$@ha@$##Service iface should be configured with a static address and gateway##$@ha@$##')).show();
          // }
          // if (heartbeat.available.length === 0) {
          //   jQuery('#jv-heartbeat-iface-warning').html(UNAS._('##$@ha@$##Heartbeat iface should be configured with a static address without gateway##$@ha@$##')).show();
          // }
          // if (disks.available.length === 0) {
          //   jQuery('#jv-volume-warning').html(UNAS._('##$@ha@$##Available volume should not be mounted##$@ha@$##')).css('color', 'red').show();
          // } else {
          //   jQuery('#jv-volume-warning').html(UNAS._('##$@ha@$##All data in the volume will be erased##$@ha@$##')).css('color', 'orange').show();
          // }

          setoption('#jv-service', service, 'service');
          setoption('#jv-heartbeat', heartbeat, 'heartbeat');

        } else {
          jQuery('#jv-service-iface-warning').html(UNAS._('##$@ha@$##' + data.errmsg + '##$@ha@$##')).show();
        }

        resolve(data);
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      },
      complete: function(xhr, status) {
        jQuery('#jv-createha-loading').hide();
      }
    });
  }).then(function(res) {
    if (jQuery('#jv-service').val() === null) {
      return;
    }
    var service = jQuery('#jv-service').val() ? jQuery('#jv-service').val().split("/")[0] : '';
    if (service) {
      get_available_ip(service);
      get_probe();
    }

  })
}

//获取ip
function get_available_ip(iface) {
  jQuery('#jv-createha-loading').show();
  jQuery.ajax({
    url: HaGlobalData.url,
    type: 'POST',
    data: JSON.encode({
      cmd: 'get_available_ip',
      token: UToken,
      params: {
        iface: iface
      }
    }),
    timeout: 60000,
    dataType: 'json',
    contentType: 'application/json',
    success: function(data) {
      if (data.err == 0) {
        if (data.results) {
          jQuery('#createtarget_ip').val(data.results);
          jQuery('#createtarget_ip').attr('class', 'unas_input');
          jQuery('#jv-createHa-btn').attr('class', 'unas_button_sub');
        } else {
          jQuery('#createtarget_ip').val('');
          jQuery('#createtarget_ip').attr('class', 'unas_input_error');
          jQuery('#jv-createHa-btn').attr('class', 'unas_button_sub_disabled');
        }
      }
      changeBtn();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    },
    complete: function(xhr, status) {
      jQuery('#jv-createha-loading').hide();
    }
  });
}

//验证集群IP是否可用
function ip_available() {
  var ip = jQuery('#createtarget_ip').val();
  if (ip === '') {
    jQuery('#jv-ip-warning').html(UNAS._('##$@ha@$##Input an IP or press Get A New IP##$@ha@$##')).css('color', 'red').show();
    return;
  }
  var service_iface_val = jQuery('#jv-service').val();
  if (service_iface_val === '') {
    jQuery('#jv-ip-warning').html(UNAS._('##$@ha@$##Select a service iface first##$@ha@$##')).css('color', 'red').show();
    return;
  }

  jQuery('#jv-ip-warning').html('').hide();
  jQuery('#createtarget_ip').attr('class', 'unas_input');

  jQuery('#jv-createha-loading').show();
  jQuery.ajax({
    url: HaGlobalData.url,
    type: 'POST',
    data: JSON.encode({
      cmd: 'ip_available',
      token: UToken,
      params: {
        iface: service_iface_val.split("/")[0],
        ip: ip
      }
    }),
    timeout: 60000,
    dataType: 'json',
    contentType: 'application/json',
    success: function(data) {

      if (data.err == 0) {
        if (data.results) {
          jQuery('#createtarget_ip').attr('class', 'unas_input');
          jQuery('#jv-ip-warning').html(UNAS._('##$@ha@$##IP address is OK##$@ha@$##')).css('color', 'green').show();
          jQuery('#jv-createHa-btn').attr('class', 'unas_button_sub');
        }
      } else {
        jQuery('#createtarget_ip').attr('class', 'unas_input_error');
        jQuery('#jv-ip-warning').html(UNAS._('##$@ha@$##' + data.errmsg + '##$@ha@$##')).css('color', 'red').show();
        jQuery('#jv-createHa-btn').attr('class', 'unas_button_sub_disabled');
      }
      changeBtn();
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      alert(textStatus);
    },
    complete: function(xhr, status) {
      jQuery('#jv-createha-loading').hide();
    }
  });
}
//获取局域网机器
function get_probe() {
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: HaGlobalData.url,
      type: 'POST',
      data: JSON.encode({
        cmd: 'probe',
        token: UToken
      }),
      timeout: 60000,
      dataType: 'json',
      contentType: 'application/json',
      success: function(data) {
        if (data.err == 0) {
          var info = data.results || [];
          if (!info.length) {
            return;
          }
          var host = {
            available: [],
            unavailable: []
          }
          for (var i = 0; i < info.length; i++) {
            var d = info[i];
            if (d.status == "available") {
              host.available.push(d);
            } else {
              host.unavailable.push(d);
            }
          }
          jQuery('#jv-slavename').attr('hostname', info[0].hostname);
          jQuery('#jv-lans').html('');
          for (var s in host) {
            var optgroup = document.createElement("optgroup");
            var op = '';
            if (s == 'available') {
              jQuery(optgroup).attr('label', UNAS._('##$@ha@$##Available##$@ha@$##'));
              if (host[s].length) {
                for (var i = 0; i < host[s].length; i++) {
                  var t = '';
                  var ip = '';
                  for (var ac = 0; ac < host[s][i].ifaces.length; ac++) {
                    ip += host[s][i].ifaces[ac].ip  + "/";
                  }

                  t = host[s][i].hostname + ' (' + ip + ')';
                  op += "<option value='" + JSON.stringify(host[s][i]) + "'>" + t + "</option>";
                }
              } else {
                jQuery('#jv-createHa-btn').attr('class', 'unas_button_sub_disabled');
                op += '<option value="" style="font-style: italic;">' + UNAS._('##$@ha@$##No available machine##$@ha@$##') + '</option>';
              }

              jQuery(optgroup).html(op);
            }
            if (s == 'unavailable') {
              jQuery(optgroup).attr('label', UNAS._('##$@ha@$##Unavailable##$@ha@$##')).attr('disabled', 'disabled');
              if (host[s].length) {
                for (var j = 0; j < host[s].length; j++) {
                  var t = '';
                  var ip = '';
                  for (var ac = 0; ac < host[s][j].ifaces.length; ac++) {
                    ip += host[s][j].ifaces[ac].ip + "/";
                  }

                  t = host[s][j].hostname + ' (' + ip + ')';
                  op += '<option value="' + ip + '">' + t + '</option>';
                }
              } else {
                op = '<option value="" style="font-style: italic;">' + UNAS._('##$@ha@$##No unavailable machine##$@ha@$##') + '</option>';
              }
              jQuery(optgroup).html(op);
            }

            jQuery('#jv-lans').append(optgroup);
          }

          var service = {
            available: [],
            unavailable: []
          }
          var heartbeat = {
            available: [],
            unavailable: []
          }

          jQuery('#jv-lans').off('change').on('change', function() {
            var ips = JSON.parse(jQuery(this).val());
            var ifaces = JSON.parse(ips.ifaces);
            var s_ = {
                available: [],
                unavailable: []
              },
              h_ = {
                available: [],
                unavailable: []
              };
            for (var i = 0; i < ifaces.length; i++) {
              var t_ = ifaces[i];
              if (i == 1) {
                t_['type'] = 'heartbeat'
              }
              s_.available.push(t_);
              h_.available.push(t_);
              jQuery('#jv-slavename').attr('hostname', ips.hostname);
            }
            setoption('#jv-service-slave', s_, 'service');
            setoption('#jv-heartbeat-slave', h_, 'heartbeat');
          });

          for (var i = 0; i < host.available[0].ifaces.length; i++) {
            var t_ = host.available[0].ifaces[i];
            if (i == 1) {
              t_['type'] = 'heartbeat'
            }
            service.available.push(t_);
            heartbeat.available.push(t_);

          }

          setoption('#jv-service-slave', service, 'service');
          setoption('#jv-heartbeat-slave', heartbeat, 'heartbeat');

        }

      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        alert(textStatus);
      },
      complete: function(xhr, status) {
        resolve(xhr);
      }
    });
  })

}
//扫描局域网
function scan_lan() {
  jQuery('#jv-createha-loading').show();
  get_probe().then(function() {
    jQuery('#jv-createha-loading').hide();
  })
}

//
function serviceipchange() {
  var e = window.event || arguments.callee.caller.arguments[0];
  var v = jQuery(e.currentTarget).val();
  if (v) {
    get_available_ip(v);
  }
}

function get_new_available_ip() {
  service_iface_val = jQuery('#jv-service').val();
  if (service_iface_val === '') {
    jQuery('#jv-ip-warning').html(UNAS._('##$@ha@$##Select a service iface first##$@ha@$##')).css('color', 'red').show();
    return;
  }
  jQuery('#createtarget_ip').attr('class', 'unas_input');
  jQuery('#jv-ip-warning').html('').hide();
  jQuery('#jv-createha-loading').show();
  var service_iface = service_iface_val.split("/")[0];
  if (service_iface) {
    get_available_ip(service_iface);
  }
}
//
function changeBtn() {
  var service = jQuery('#jv-service').val() ? jQuery('#jv-service').val().split("/")[1] : '';
  service = service == '--' ? '' : service;
  var heartbeat = jQuery('#jv-heartbeat').val();
  heartbeat = heartbeat == '--' ? '' : heartbeat;
  var ip = jQuery('#createtarget_ip').val();
  var is_ip = jQuery('#createtarget_ip').attr('class') == 'unas_input' ? 1 : 0;

  var lans = jQuery('#jv-lans').val();
  var service2 = jQuery('#jv-service-slave').val() ? jQuery('#jv-service-slave').val().split("/")[1] : '';
  service2 = service2 == '--' ? '' : service2;
  var heartbeat2 = jQuery('#jv-heartbeat-slave').val();
  heartbeat2 = heartbeat2 == '--' ? '' : heartbeat2;

  var pwd1 = jQuery('#jv-pwd-1').val();
  var pwd2 = jQuery('#jv-pwd-2').val();
  var name = jQuery('#jv-haname').val();

  var disks = jQuery('#jv-diskhost input[name="disk"]:checked').length;

  if (service && heartbeat && lans && pwd1 && pwd2 && name &&
    ip && is_ip && disks && service2 && heartbeat2) {
    jQuery('#jv-createHa-btn').attr('class', 'unas_button_sub');
  } else {
    jQuery('#jv-createHa-btn').attr('class', 'unas_button_sub_disabled');
  }
}
//
function setoption(target, data, type) {

  jQuery(target).html('');
  var n = 0;
  for (var s in data) {
    if (data[s].length) {
      n = 1;
    }
    var optgroup = document.createElement("optgroup");
    var op = '';
    if (s == 'available') {
      jQuery(optgroup).attr('label', UNAS._('##$@ha@$##Available##$@ha@$##'));
      if (data[s].length) {
        for (var i = 0; i < data[s].length; i++) {
          var t = '';
          if (type == 'disks') {
            t = data[s][i].disk + ' (' + UNAS.getReadableSizeString(data[s][i].size) + ')';
            op += '<option value=' + data[s][i].disk + '>' + t + '</option>';
          } else {
            var selected = '';
            if (type == "heartbeat" && data[s][i].type == "heartbeat") {
              selected = 'selected';
            }
            t = data[s][i].ifname + ' (' + (data[s][i].ip || '--') + '/' + (data[s][i].mask || '--') + ')';
            if (type == 'service') {
              op += '<option value="' + (data[s][i].ifname + "/" + (data[s][i].ip || '--')) + '">' + t + '</option>';
            } else {
              op += '<option value="' + (data[s][i].ip || '--') + '"' + selected + '>' + t + '</option>';
            }
          }
        }
      } else {
        if (type == 'disks') {
          op += '<option value="" style="font-style: italic;">' + UNAS._('##$@ha@$##No available volume##$@ha@$##') + '</option>';
        } else {
          op += '<option value="" style="font-style: italic;">' + UNAS._('##$@ha@$##No available iface##$@ha@$##') + '</option>';
        }
      }

      jQuery(optgroup).html(op);
    }
    if (s == 'unavailable') {
      jQuery(optgroup).attr('label', UNAS._('##$@ha@$##Unavailable##$@ha@$##')).attr('disabled', 'disabled');
      if (data[s].length) {
        for (var j = 0; j < data[s].length; j++) {
          var t = '';
          if (type == 'disks') {
            t = data[s][j].disk + ' (' + UNAS.getReadableSizeString(data[s][j].size) + ')';
            op += '<option value=' + data[s][j].disk + '>' + t + '</option>';
          } else {
            t = data[s][j].ifname + ' (' + (data[s][j].ip || '--') + '/' + data[s][j].mask + ')';
            if (type == 'service') {
              op += '<option value="' + (data[s][j].ifname + "/" + data[s][j].ip) + '">' + t + '</option>';
            } else {
              op += '<option value="' + data[s][j].ifname + '">' + t + '</option>';
            }
          }
        }
      } else {
        if (type == 'disks') {
          op += '<option value="" style="font-style: italic;">' + UNAS._('##$@ha@$##No unavailable volume##$@ha@$##') + '</option>';
        } else {
          op += '<option value="" style="font-style: italic;">' + UNAS._('##$@ha@$##No unavailable iface##$@ha@$##') + '</option>';
        }
      }

      jQuery(optgroup).html(op);
    }

    jQuery(target).append(optgroup);

  }
}

function changeF() {
  document.getElementById('makeupCo').value =
    document.getElementById('makeupCoSe').options[document.getElementById('makeupCoSe').selectedIndex].value;
}

//创建ha
function createCluster() {

  haManagerAlertWindow(UNAS._('##$@ha@$##Create High Availability##$@ha@$##'), UNAS._('##$@ha@$##Confirm Create##$@ha@$##'), function() {
    create_ha();
  }, 0, "", UNAS._("##$@ha@$##Please review your selection and input carefully. They cannot be modified after creation. Generally, it takes 2-5 minutes to process, please wait patiently.##$@ha@$##"));
}


function create_ha() {

  var nodes = [{
    "host": jQuery('#jv-mastername').attr('hostname'),
    "ip": "",
    "hb_ip": "",
    "pass": jQuery('#jv-pwd-1').val(),
    "disk": []
  }, {
    "host": jQuery('#jv-slavename').attr('hostname'),
    "ip": "",
    "hb_ip": "",
    "pass": jQuery('#jv-pwd-2').val(),
    "disk": []
  }];
  var cluster_name = jQuery('#jv-haname').val();

  nodes[0]['ip'] = jQuery('#jv-service').val().split("/")[1];
  nodes[0]['hb_ip'] = jQuery('#jv-heartbeat').val();
  nodes[1]['ip'] = jQuery('#jv-service-slave').val().split("/")[1];
  nodes[1]['hb_ip'] = jQuery('#jv-heartbeat-slave').val();

  var ip = jQuery('#createtarget_ip').val();

  var monitor_service = [];

  jQuery('#jv-diskhost input[name="disk"]:checked').each(function(i, e) {
    nodes[0]['disk'].push(jQuery(e).val());
    nodes[1]['disk'].push(jQuery(e).val());
  });

  jQuery('#jv-monitor-service input[type=checkbox]').each(function(i, e) {
    if (e.checked) {
      monitor_service.push(jQuery(e).attr('tv'));
    }
  })

  jQuery('#jv-createha-loading').show();
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: HaGlobalData.url,
      type: 'POST',
      data: JSON.encode({
        cmd: 'create_ha',
        token: UToken,
        params: {
          cluster_name: cluster_name,
          nodes: nodes,
          ha_ip: ip,
          monitor_service: monitor_service
        }
      }),
      timeout: 6000000,
      dataType: 'json',
      contentType: 'application/json',
      success: function(data) {
        if (data.err == 0) {
          MUI.closeWindow($('jv-createHaClusterWindow'));
          ha_status();
        } else {
          errWindow(UNAS._('##$@ha@$##' + data.errmsg + '##$@ha@$##'), function() {
            jQuery('#jv-createha-loading').hide();
          });
        }

        resolve(data);
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {
        errWindow(UNAS._('##$@ha@$##Failed to create High Availability##$@ha@$##'));
      },
      complete: function(xhr, status) {
        jQuery('#jv-createmb').remove();
        jQuery('#jv-createha-loading').hide();
      }
    });
  })

}

function clusternav(t) {
  var event = window.event || arguments.callee.caller.arguments[0];
  var that = jQuery(event.currentTarget);
  that.attr('class', 'unas_tab_sel').siblings().attr('class', 'unas_tab');
  jQuery('.jvc-conftype').eq(t).show().siblings('.jvc-conftype').hide();
}

(function() {

  get_host_conf();
  get_probe();

  jQuery('#makeupCo').click(function() {

  });

  jQuery('#makeupCo').bind('input propertychange', function() {
    jQuery('#makeupCoSe').val(jQuery(this).val());
  })

  jQuery('#jv-pwd-1, #jv-pwd-2, #createtarget_ip, #jv-haname').bind('input propertychange', function() {
    changeBtn();
  })

  jQuery('#jv-selAlldisk').on('click', function(e) {
    var disks = jQuery('#jv-diskhost input[name="disk"]');

    if (!disks.length) {
      return;
    }
    if (this.checked) {
      disks.prop('checked', true);
    } else {
      disks.prop('checked', false);
    }

    changeBtn();
  })

})();
