function ha_status() {
  return new Promise(function(resolve, reject) {
    jQuery.ajax({
      url: HaGlobalData.url,
      type: 'POST',
      data: JSON.encode({
        cmd: 'ha_status',
        token: UToken
      }),
      timeout: 10000,
      dataType: 'json',
      contentType: 'application/json',
      success: function(data) {
        if (data.err == 0) {
          var info = data.results || {};
          jQuery('#jv-errormsg').empty();
          jQuery('#jv-ha-status').empty();
          jQuery('#jv-mastheartbeat').empty();
          jQuery('#jv-mastservice').empty();
          jQuery('#jv-monitor-service').empty();
          jQuery('#jv-slaveheartbeat').empty();

          jQuery('#jv-slaveservice').empty();

          if (info.node && info.node.length) {

            jQuery('#jv-monitor-service').text(info.cluster_name || '');
            info.node[0] = info.node[0] || {};
            info.node[1] = info.node[1] || {};

            var masterservice = '',
              masterheartbeat = '';
            var iface_0 = info.node[0].iface || {};
            var iface_1 = info.node[1].iface || {};
            var clusterinfo = info.cluster_ip || {};
            var cluster_ip = info.cluster_ip.addr || "";

            setiface(iface_0, cluster_ip, '#jv-mastservice');
            setiface(iface_1, cluster_ip, '#jv-slaveservice');
          }

          // info.status = 1
          switch (info.status) {
            case 0:
              jQuery('#jv-hanulldata').show();
              jQuery('#jv-statusimg').attr('src', '/apps/ha/images/create_Image.png?v=6.1.14&');
              jQuery('#jv-create-clu').css('display', 'inline-block');
              jQuery('#jv-warningtips').hide();
              jQuery('#jv-hacontainer').hide();
              jQuery('#jv-errormsg').text(UNAS._('##$@ha@$##High Availability is not configured##$@ha@$##'));
              jQuery('#jv-haclusterwarningtips').hide();
              break;
            case 1:
              jQuery('#jv-hacontainer').show();
              jQuery('#jv-hanulldata').hide();

              jQuery('#jv-haclusterwarningtips').hide();
              jQuery('#ha_quorum_tab').show();

              if (info.quorum) {
                jQuery('#ha_quorum_server_add').hide();
                jQuery('#ha_quorum_server_leave').show();
                jQuery('#ha_quorum_server').val(info.quorum).attr('disabled', true);
                jQuery('#ha_quorum_passwd_li').hide();
                jQuery('#jv-arbitrationservershow').show();
                jQuery('#jv-arbitrationserver').text(info.quorum);
                jQuery('#jv-ha-line').attr('src', '/apps/ha/images/ha_line.png?v=6.1.14&');
              } else {
                jQuery('#ha_quorum_server_add').show();
                jQuery('#ha_quorum_server_leave').hide();
                jQuery('#ha_quorum_server').attr('disabled', false);
                jQuery('#ha_quorum_passwd_li').show();
                jQuery('#jv-arbitrationservershow').hide();
                jQuery('#jv-ha-line').attr('src', '/apps/ha/images/ha_line_n.png?v=6.1.14&');
              }

              break;
            case 2:
              jQuery('#jv-hanulldata').show();
              jQuery('#jv-hacontainer').hide();
              jQuery('#jv-statusimg').attr('src', '');
              jQuery('#jv-create-clu').css('display', 'none');
              jQuery('#jv-warningtips').hide();
              jQuery('#jv-hacontainer').hide();
              jQuery('#jv-haclusterwarningtips').hide();
              jQuery('#jv-errormsg').html('<p class="syncingimg"></p><span>' + UNAS._('##$@ha@$##Creating High Availability##$@ha@$##') + '</span><dot></dot>');
              break;
            case 3:
              jQuery('#jv-hanulldata').show();
              jQuery('#jv-statusimg').attr('src', '/apps/ha/images/failed_Image.png?v=6.1.14&');
              jQuery('#jv-create-clu').css('display', 'inline-block');
              jQuery('#jv-warningtips').show();
              jQuery('#jv-hacontainer').hide();
              jQuery('#jv-errormsg').text(UNAS._('##$@ha@$##Failed to create High Availability##$@ha@$##'));
              jQuery('#jv-haclusterwarningtips').hide();
              break;
            case 4:
              break;
            case 5:
              jQuery('#jv-haclusterwarningtips').show();
              break;
            case 6:
              break;
            case 7:
              jQuery('#jv-hacontainer').show();
              jQuery('#jv-hanulldata').hide();
              jQuery('#jv-haclusterwarningtips').hide();
              jQuery('#jv-ha-status').html('<div><span>' +
                UNAS._('##$@ha@$##Synchronizing##$@ha@$##') +
                '</span><dot></dot><p class="syncingimg"></p><p style="color:#0CCA8A;">ETF: ' + '--' + '</p></div>');

              if (info.quorum) {
                jQuery('#jv-ha-line').attr('src', '/apps/ha/images/ha_line.png?v=6.1.14&');
              } else {
                jQuery('#jv-ha-line').attr('src', '/apps/ha/images/ha_line_n.png?v=6.1.14&');
              }
              break;
            default:
              jQuery('#jv-hanulldata').show();
              jQuery('#jv-hacontainer').hide();
              jQuery('#jv-haclusterwarningtips').hide();
              jQuery('#jv-errormsg').text(UNAS._('##$@ha@$##Unknown status##$@ha@$##'));
          }

        } else {
          jQuery('#jv-hanulldata').show();
          jQuery('#jv-hacontainer').hide();
          jQuery('#jv-haclusterwarningtips').hide();
          jQuery('#jv-errormsg').text(UNAS._('##$@ha@$##' + (data.errmsg || '') + '##$@ha@$##'));
        }
        resolve(data);
      },
      error: function(XMLHttpRequest, textStatus, errorThrown) {

      },
      complete: function(xhr, status) {
        ha_host_top();
      }
    });
  })
}

function setiface(iface, cluster_ip, t) {
  for (var v in iface) {
    if (iface.hasOwnProperty(v)) {
      var addr_info = iface[v].addr_info || [];
      var m_ip = [];
      if (addr_info.length) {
        for (var i = 0; i < addr_info.length; i++) {
          var addr_t = addr_info[i];
          if (addr_t.family == "inet") {
            if (cluster_ip == addr_t.local) {
              m_ip.unshift('<span style="color: blue;">' + addr_t.local + '</span>');
            } else {
              m_ip.push(addr_t.local);
            }
          }
        }
        jQuery(t).append('<div>' + v + ' (' + m_ip.join('/') + ")" + '</div>');
      }
    }
  }
}

function ha_host_top() {
  HaGlobalData.lastStartTime = new Date().getTime();
  clearTimeout(halastTimer);
  jQuery.ajax({
    url: HaGlobalData.url,
    type: "POST",
    async: true,
    data: JSON.encode({
      "cmd": "ha_host_top",
      "token": UToken
    }),
    timeout: 30000,
    dataType: "json",
    contentType: "application/json",
    success: function(res) {

      var info = res.results || {};
      var node = info.node || [];
      if (node.length) {
        node[0] = node[0] || {};
        node[1] = node[1] || {};
        jQuery('#jv-slavehostname').empty();
        jQuery('#jv-masterhostname').empty();
        jQuery('#jv-mastreplace').empty();
        jQuery('#jv-slavereplace').empty();

        jQuery('#jv-masterhostname').html('<span>' + (node[0].name || '') + '</span>');
        jQuery('#jv-slavehostname').html('<span>' + (node[1].name || '') + '</span>');

        if (node[0].online) {
          jQuery('#jv-masterstatusbg').addClass('Online-bg');
          jQuery('#jv-masterhostname').append('<span class="ha-Online">Online</span>');
        } else {
          jQuery('#jv-masterstatusbg').addClass('Offline-bg');
          jQuery('#jv-masterhostname').append('<span class="ha-Offline">Offline</span>');
          jQuery('#jv-mastreplace').text(UNAS._('##$@ha@$##Replace##$@ha@$##')).css({
            color: '#fff',
            cursor: 'pointer'
          }).on('click', function() {
            replaceWindow();
          });
        }
        if (node[1].online) {
          jQuery('#jv-slavestatusbg').removeClass('Offline-bg');
          jQuery('#jv-slavestatusbg').addClass('Online-bg');
          jQuery('#jv-slavehostname').append('<span class="ha-Online">Online</span>');
        } else {
          jQuery('#jv-slavestatusbg').removeClass('Online-bg');
          jQuery('#jv-slavestatusbg').addClass('Offline-bg');
          jQuery('#jv-slavehostname').append('<span class="ha-Offline">Offline</span>');
          jQuery('#jv-slavereplace').text(UNAS._('##$@ha@$##Replace##$@ha@$##')).css({
            color: '#fff',
            cursor: 'pointer'
          }).on('click', function() {
            replaceWindow();
          });
        }

        jQuery('#jv-mastreplace').data('memberinfo', node[0]);
        jQuery('#jv-slavereplace').data('memberinfo', node[1]);

        var usage0 = node[0].usage,
          usage1 = node[1].usage;
        var cpuuse0 = 0,
          cpuuse1 = 0;
        var ramuse0 = 0,
          ramuse1 = 0;
        if (usage0) {
          cpuuse0 = usage0.cpu;
          ramuse0 = parseInt((usage0.mem.used / usage0.mem.total) * 100);
        }
        if (usage1) {
          cpuuse1 = usage1.cpu;
          ramuse1 = parseInt((usage1.mem.used / usage1.mem.total) * 100);
        }

        if (cpuuse0 > 50 && cpuuse0 < 90) {
          jQuery('#jv-master-cpu-progress').addClass('progress-color-2');
        } else if (cpuuse0 >= 90) {
          jQuery('#jv-master-cpu-progress').addClass('progress-color-3');
        } else {
          jQuery('#jv-master-cpu-progress').addClass('progress-color-1');
        }
        if (ramuse0 > 50 && ramuse0 < 90) {
          jQuery('#jv-master-ram-progress').addClass('progress-color-2');
        } else if (ramuse0 >= 90) {
          jQuery('#jv-master-ram-progress').addClass('progress-color-3');
        } else {
          jQuery('#jv-master-ram-progress').addClass('progress-color-1');
        }

        jQuery('#jv-master-cpu-progress').css('width', cpuuse0 + '%');
        jQuery('#jv-master-cpuuse').text(cpuuse0 + '%');
        jQuery('#jv-master-ram-progress').css('width', ramuse0 + '%');
        jQuery('#jv-master-ramuse').text(ramuse0 + '%');

        if (cpuuse1 > 50 && cpuuse1 < 90) {
          jQuery('#jv-slave-cpu-progress').addClass('progress-color-2');
        } else if (cpuuse1 >= 90) {
          jQuery('#jv-slave-cpu-progress').addClass('progress-color-3');
        } else {
          jQuery('#jv-slave-cpu-progress').addClass('progress-color-1');
        }
        if (ramuse1 > 50 && ramuse1 < 90) {
          jQuery('#jv-slave-ram-progress').addClass('progress-color-2');
        } else if (ramuse1 >= 90) {
          jQuery('#jv-slave-ram-progress').addClass('progress-color-3');
        } else {
          jQuery('#jv-slave-ram-progress').addClass('progress-color-1');
        }

        jQuery('#jv-slave-cpu-progress').css('width', cpuuse1 + '%');
        jQuery('#jv-slave-cpuuse').text(cpuuse1 + '%');
        jQuery('#jv-slave-ram-progress').css('width', ramuse1 + '%');
        jQuery('#jv-slave-ramuse').text(ramuse1 + '%');

      }

    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {},
    complete: function() {
      var endTime = new Date().getTime();
      var timeout = endTime - HaGlobalData.lastStartTime;
      if (timeout > 10000) {
        ha_host_top();
      } else {
        halastTimer = setTimeout(function() {
          jQuery('#jv-hamanager-page').length && ha_host_top();
        }, 10000 - timeout);
      }
    }
  });
}

function ha_quorum_error(msg = null, part = 'server') {
  if (msg) {
    jQuery('#ha_quorum_' + part + '_warning').show().attr('title', UNAS._('##$@ha@$##' + msg + '##$@ha@$##'));
  } else {
    jQuery('#ha_quorum_server_warning').hide().attr('title', '');
    jQuery('#ha_quorum_passwd_warning').hide().attr('title', '');
  }
}

function ha_quorum() {
  ha_quorum_error();
  haManagerLoadingShow();
  jQuery.ajax({
    url: HaGlobalData.url,
    type: "POST",
    async: true,
    data: JSON.encode({
      "cmd": "ha_quorum",
      "token": UToken,
      "params": {
        "qdev": jQuery('#ha_quorum_server').val(),
        "passwd": jQuery('#ha_quorum_passwd').val(),
      }
    }),
    timeout: 30000,
    dataType: "json",
    contentType: "application/json",
    success: function(data) {
      switch (data.err) {
        case 0:
          // Succeed
          ha_status();
          break;

        case 9920:
          // Connect failed
          ha_quorum_error('Cannot connect to quorum server');
          break;

        case 9951:
          // qDevice not ready
          ha_quorum_error('The server is not configured as a quorum server');
          break;

        case 9982:
          // Already configured
          ha_status();
          break;

        case 9988:
          // Authorize failed
          ha_quorum_error('Server authorize failed', 'passwd');
          break;

        case 9995:
          // Param error
          ha_quorum_error('Input error');
          break;

        default:
          break;
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {},
    complete: function() {
      haManagerLoadingHide();
    }
  });
}

function ha_quorum_leave() {
  ha_quorum_error();
  haManagerLoadingShow()
  jQuery.ajax({
    url: HaGlobalData.url,
    type: "POST",
    async: true,
    data: JSON.encode({
      "cmd": "ha_quorum_leave",
      "token": UToken,
    }),
    timeout: 30000,
    dataType: "json",
    contentType: "application/json",
    success: function(data) {
      switch (data.err) {
        case 0:
          // Succeed
          ha_status();
          break;

        case 9939:
          // No quorum
          ha_quorum_error('Quorum not configured');
          break;

        default:
          break;
      }
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {},
    complete: function() {
      haManagerLoadingHide();
    }
  });
}

function createHaCluster() {
  var createHaClusterWindow = new MUI.Modal({
    id: 'jv-createHaClusterWindow',
    title: UNAS._('##$@ha@$##Create High Availability##$@ha@$##'),
    modal: true,
    modalOverlayClose: false,
    width: 890,
    height: 640,
    contentURL: '/apps/ha/createhacluster.html?v=6.1.14&'
  });
}

function replaceWindow() {
  var e = window.event || arguments.callee.caller.arguments[0];
  var v = jQuery(e.currentTarget).data('memberinfo');
  var t = jQuery(e.currentTarget).attr('type');
  var ReplacememberWindow = new MUI.Modal({
    id: 'jv-replacememberWindow',
    title: UNAS._('Replace Server'),
    modal: true,
    modalOverlayClose: false,
    width: 888,
    height: 430,
    data: v,
    replacetype: t,
    contentURL: '/apps/ha/replace.html?v=6.1.14&'
  });
}

(function() {

  ha_status();
})();
